use std::thread;
use std::sync::Arc;
use std::sync::RwLock;

fn subtract(s: Arc<RwLock<i32>>) {
    for _ in 0..5000 {
        let mut s_w = s.write().unwrap();
        let mut aux = *s_w;
        aux = aux - 1;
        *s_w = aux;
    }
}

fn main() {
    let var = RwLock::new(10000);
    let s = Arc::new(var);
    let mut children = vec![];
    let cant_hijos = 2;

    for _ in 0..cant_hijos {
        let reference = Arc::clone(&s);
        children.push(thread::spawn( move || {
            subtract(reference);
        }));
    }

    for handle in children {
        handle.join().unwrap();
    }

    println!("El total es de {}", s.read().unwrap());
}
